!     Last change:  ZK   15 Sep 2018    3:11 pm

!.. THIS PROGRAM COMPUTES wave  in 1D channel
!.. program originated by Z.K. at Univ. of Alaska
!.. PROGRAM TESTED BY W.K.
!.. ALL UNITS CGS
!.. Computation based on eqs. II.55 and II.56 from book
      Program resonance
      Implicit NONE
      INTEGER,PARAMETER :: JE=421, MON=30001            ! mon is total number of time steps
      REAL, DIMENSION(1:JE) :: U, UN, Z, ZN, H, H1      !H IS DEPTH
      REAL,PARAMETER :: T=0.2, DX=1000., G=981., R=0.00
      REAL,PARAMETER :: PI=3.1415926535897
      REAL :: PL, PLG, B, Zmax,TP    ! TP TSUNAMI PERIOD
      INTEGER:: j, MO, NS
! OPEN (unit=10,file='reson_v.dat',status='unknown')
      OPEN (unit=10,file='reson_ZF.dat',status='unknown')
      OPEN (unit=11,file='reson_time.dat',status='unknown')

      PRINT*, "READ PERIOD  IN MINUTES  "
      READ*, TP
      PRINT*,TP  ! JUST TO CHECK
      TP=60*TP   !PERIOD IN SEC.
!.. if B=1 total depth is computed H1=H+Z
      B=0.


!.. NUMBER OF TIME STEPS IN TSUNAMI PERIOD
      NS=INT(TP/T)  ! for tp=1200SEC, NS=6000

!.. COEFFICIENTS FOR EQUATIONS & INITIALIZATIONS
      PL=T/DX
      PLG=G*PL
      H1=2000.
      H=H1
      UN=0.
      U=0.
      ZN=0.
      Z=0.
      Zmax = 0.

!.. start time loop
      DO MO = 1, MON
       ! IF (MOD(MO, 100) .EQ. 1) print*, 100.*float(MO)/float(MON), " % done"

!.. lEFT BOUNDARY CONTINUOUS INPUT TO THE RIGHT  AND RADIATION TO THE LEFT
        ZN(1)=100.*sin(2.*pi*t*float(MO-1)/TP)&
         -U(2)*SQRT(h(2)/g)
 	UN(JE)=0.                         !reflection at the right end
!.. UN(2)=U(2)-PLG*(Z(2)-Z(1))            ! VELOCITY AT THE FIRST GRID POINT

!.. compute velocity
	DO J=2,JE-1
	  UN(J)=U(J)-PLG*(Z(J)-Z(J-1)) &
           -r*u(j)*ABS(u(j))/H(J)         !FRICTION AT THE BOTTOM
        END DO
 
!.. compute sea level
	DO J=2,JE-1
	  ZN(J)=Z(J)+PL*(UN(J)*(H1(J)+H1(J-1))/2.0 &
            -UN(J+1)*(H1(J+1)+H1(J))/2.)
        END DO

!.. CHANGE OLD VARIABLES TO NEW
        U=UN
        H1=H+B*ZN
        Z=ZN
 

        IF(z(3) .gt. zmax) zmax=z(3)
        IF(mo .eq. mon-1)then
!.. BY WRITING ZMAX FOR DIFFERENT PERIODS THE FIG.II.13 CAN BE CONSTRUCTED
         open(21,file="ZMAX_PERIOD.dat",status="unknown",POSITION="append",action="write")
         write(21,*) zmax,tp/60
             close(UNIT=21)
          END if
!.. PRINT MAX VALUE FOR EVERY PERIOD TO SEE CONVERGENCE
!..     IF(MOD(mo,ns) .eq. 0)then
        IF(MOD(mo, ns) .EQ. 0 .AND. mo .LT. (mon -ns)) then
          PRINT*,'zmax=',zmax
          zmax=0.
        END IF

        IF(MOD(MO,10).EQ.0)THEN            ! THIS IS TO MAKE MOVIES/ANIMATIONS
          DO j=1,je
	    WRITE (11,*)z(j)
          END DO
        END IF

!..write SEA LEVEL OR VELOCITY AT HALF A PERIOD DISTANCE, HERE FOR 20 MIN
!..NS=6000 NS/2=3000.
!.. IF(MO.EQ.29999-4500.OR.MO.EQ.29999-1500)THEN ! vel first mode
!        IF(MO .EQ. 29999-3000 .OR. MO .EQ. 29999)THEN  SEA LEVEL
        IF(MO .EQ. 29999-INT(NS/2).OR. MO .EQ. 29999)THEN              ! level first mode
          DO j=1,je
	    WRITE (10,*)Zn(j)              !or un(j)
          END DO
	END IF
      END DO                               !END COMPUTATION

      PRINT*,"MO=",MO, " DONE"
      END  PROGRAM resonance
