!     Last change:  ZK   18 Sep 2018    3:53 pm
      PROGRAM RUNUP

!.. Last change:  ZK    1 Dec 2008    9:15 pm
!.. THE BEST CONTROL OF A RUNUP IS BY INVOKING TWO SEA LEVEL
!.. POINTS FOR THE VELOCITY IN
!.. CONTINUITY EQUATION
!.. THIS IS WHY WE NEED TO WORK WITH THE FLUX ON ONE SURFACE
!.. ONLY IN EQ. OF CONTINUITY.
!.. FLUXES ON TWO SURFACE INVOKE AT LEAST 3 SEA LEVEL POINTS AND DRY/WET CONDITION BECOMES
!.. OBFUSCATE.
!..  program originated by Z.K. at Univ. of Alaska
!.. reworked  by W.K.
      INCLUDE "block_parab.f90"


!..       Note -- all units are in CGS (Set density = 1)
!..         --  +  --  + --  +      SPACE LOCATION OF SEA LEVEL AND VELOCITY
!..         U   Z  U   Z  U  Z
!..          J-1     J    J+1       GRID ENUMERATION

      CHARACTER*16 argm
      REAL    ::  HTOT
      Integer :: Mmax, Mmin

!.. initializations
      M=0
      Cell = 0
      Flux = 0.0
      SLMI=1000.
      SLMA=0.
      Mmax = 0
      Mmin = 0
      UO=0; UN=0; SLO=0; SLN=0; D=0; H=0.

      open(unit=15,file='LEVEL_ANALYTIC_PARAB.dat')
      open(unit=16,file='level_analytic.dat')

      CALL PARABOLIC()                ! DEPTH AND INITIAL SEA LEVEL


      DO M = 1, ME                    !TIME LOOP
        IF (MOD(M, 100) .EQ. 1) print*, 100.*float(m)/float(ME), " % done  Slevels ", &
         slo(50)/100., slan(50)/100.

      !---------------------boundary-------------------
!..   LEFT BOUNDARY CONDITION IS FORCING WHEN AT THE LEFT
!..   SIDE THE SEA LEVEL IS GIVEN:

!       CALL LEFT_FORCING()
!       CALL RIGHT_RADIATING()

!       SLN(JS)=SLO(JS)

        CALL analytic()                  ! get analytic solution sl = f(x, t)

      !-----------------------depths---------------------
      !---------------& define WET-DRY cells-------------
        D = H+SLO
        DO j=js,je
          IF (D(J) .LT. EPSILON)THEN
            SLO(J)=-H(J)
            CELL(J)=0.
          ELSE  IF (D(J) .GE. EPSILON) THEN
            CELL(J)=1.
          END IF
        END DO

!THIS IS ACTUALLY RUNUP
!GO TO 21
        CALL runup_rundown()
        DO j = JS+1, JE - 1
          IF (Cell(j) .EQ. 1 .AND. CELL(J+1) .EQ. 0) then ! dRY TO
            if ((SLO(j) + h(j+1)) .GT. EPSILON) then    !RIGHT
              D(J+1)= SLO(j) + h(j+1)
              Cell(j+1) = 1
 !            SLO(J+1) = SLO(j)
              if (CELL(J-1) .EQ. 1)THEN
                UO(J+1)=UO(J)
              end if
              if (CELL(J-1) .EQ. 0) THEN   !CELL SURROUNDED BY
                UO(J+1)=SQRT(G*D(J+1)) ! DRY CELLS
              end if
            end if
          END IF

          IF (CELL(J-1) .EQ. 0 .AND. CELL(J) .EQ. 1) THEN
            if ((SLO(J) + H(J-1)) .GT. EPSILON) then
            D(J-1)= SLO(J) + H(J-1)
              CELL(J-1) = 1
   !          SLO(J-1) = SLO(J)        !
              IF(CELL(J+1) .EQ. 1)THEN
              UO(J)=UO(J+1)
           END IF
             IF(CELL(J+1) .EQ. 0)THEN !CELL(J) SURROUNDER
                UO(J)=-SQRT(G*D(J-1)) !BY DRY CELLS
               END IF
             END IF
         END IF
        END DO

GO TO 89
        ! SETTING VELOCITY ALONG X

        DO J=JS+1,JE-1
          IF (CELL(J) .EQ. 0 .AND. Cell(j-1) .EQ. 0) THEN
            UO(J)=0.
          END IF
        END DO

        DO j = JS+1, JE - 1        ! CHANGE 1  TO 2 FOR RADIATION
          IF (Cell(j) .EQ. 1 .AND. CELL(J+1) .EQ. 0) then
            if ((SLO(j) + h(j+1)) .LE. EPSILON) THEN    ! FOR THE BOUNDARY CONDITION U=0
              UO(J+1)=0.                      ! AT THE RIGHT WALL
            end if
          END IF

          IF (CELL(J-1) .EQ. 0.AND. CELL(J) .EQ. 1) THEN
            if ((SLO(j) + h(j-1)) .LE. EPSILON) THEN    ! FOR THE BOUNDARY CONDITION U=0
              UO(J)=0.                      ! AT THE LEFT WALL
            end if
          END IF
        END DO
!GO TO 89

        DO j = JS+1, JE-1
          IF (Cell(j) .EQ. 1 .AND. CELL(J+1) .EQ. 0) then
            if ((SLO(j) + h(j+1)) .LE.EPSILON) THEN    ! FOR THE BOUNDARY CONDITION U=0
              HTOT= H(J)+SLO(J)
              if (HTOT .Le. 0) HTOT=10.
              UO(J+1)=  SLO(J)/SQRT(HTOT/G)                     ! AT THE RIGHT WALL
            end if
          END IF

          IF (CELL(J-1) .EQ. 0 .AND. CELL(J) .EQ. 1) THEN
            if ((SLO(j) + h(j-1)) .LE. EPSILON) THEN    ! FOR THE BOUNDARY CONDITION U=0
              HTOT= H(J)+SLO(J)
              if (HTOT .Le. 0) HTOT=10.
              UO(J)= - SLO(J)/SQRT(HTOT/G)
                                     ! AT THE LEFT WALL
            end if
          END IF
        END DO
   89 CONTINUE

   21 CONTINUE

!.. JUST FOR QUICK ORIENTATION
        DO j=JS+1,je-1 
          IF (SLO(J) .GT. SLMA) THEN
            SLMA=SLO(J)
            Mmax = m
          END IF
          IF(SLO(J) .LT. SLMI) THEN
            SLMI=SLO(J)
            Mmin = m
          END IF
        END DO


!.. ONLY ONE SUBROUTINE FOR VELOCITY, BUT FOR BEACH4 IT HAS TO BE MODIFIED
!.. FOR RADIATION AT RIGHT END OFFSET DOMAIN
        CALL VELOCITY()

!       >>>Update    SLO   first<<<
!..  CONTINUITY
        CALL CONT()

!.. CHANGE VARIABLES
        SLO=SLN
        UO=UN

!.. write out some data
        CALL WRITER_BEACH

      END  DO  ! END OF TIME LOOP
      close(15)
      close(16)
 
      PRINT*, 'SLMAX=',SLMA, ' at time step ', Mmax
      PRINT*, 'SLMIN=',SLMI, ' at time step ', Mmin
      PRINT*, " DONE"
close(77)

    CONTAINS


!.. BATHYMETRY and initial sea level distribution
      SUBROUTINE PARABOLIC()
      REAL, PARAMETER :: W = 63.0E+05
      REAL, PARAMETER :: S0_start = 10.0E+05
      REAL, PARAMETER :: H_0= 2.0E+05
      REAL :: x, a, b, c

!.. define constants      
      a=S0_START/w
      b=2.*a*h_0
      c=a*h_0/w
      X=0.

!.. Create parabolic trough
      DO J = 1, JE
        x = float(J - JE/2) * HX
        H(J) = H_0 * (1. - (x/W)**2.)
        slO(j)=c*(2.*x-s0_START)
      END DO
      SLN = SLO

      DO J=JS+1,JE
        DHU(J)=(H(j-1)+H(J))*0.5
      END DO
      DHU(JS)=DHU(JS+1)

      END SUBROUTINE



      SUBROUTINE analytic()

      REAL, PARAMETER :: W = 63.0E+05
      REAL, PARAMETER :: S0_start = 10.0E+05
      REAL, PARAMETER :: H_0 = 2.0E+05
      REAL :: x, a, b, c, omega, arg

!.. intializations and useful coefficients
      X=0.
      a=S0_START/w
      b=2.*a*h_0
      c=a*h_0/w
      omega=sqrt(2.*g*h_0)/w
 


!.. repaired - this one works - so we need to investigate more  9-10-2018  BK
      DO J = 1, JE
        arg = omega*T*float(m)
        x = float(J - JE/2) * HX
         SLAN(j)=c*(2*x*COS(arg)-0.5*S0_start*COS(2.*arg)-0.5*S0_start)
        IF ((SLAN(j)+H(j)) .LT. 0.) SLAN(j) = -H(j)
      END DO

      END SUBROUTINE



      SUBROUTINE BEACH1()   ! SLOPING SHORE LINE

      DO j=js,jE
        H(j)=1005.-float(j)*5.
      END DO

      DO j=js+1,je
        DHU(j)=(H(j-1)+H(J))*0.5
      END DO    ! DEPTH AT THE U POINTS
      DHU(JS)=DHU(JS+1)

      END SUBROUTINE



! BOUNDARY CONDITIONS
      SUBROUTINE LEFT_FORCING()
      REAL    :: W,AM,DJS1

      W=2*PI/TP
      AM=200.

      DJS1=H(JS+1)+SLO(JS)                                !
      SLO(js)=am*sin(w*m*T)-UO(JS+1)*SQRT(DJS1/G)
  !           SLO(JS)=SLO(JS)+(UO(JS+1)-UNR)*SQRT(h(JS+1)/G)
      SLN(JS)=SLO(JS)

      END SUBROUTINE



      SUBROUTINE RIGHT_FORCING()
      REAL :: W, AM

      W=2*PI/TP
      AM=100.

      SLO(jE)=am*sin(w*m*T) -uO(JE)*SQRT(h(JE)/g)
      SLN(JE)=SLO(JE)

      END SUBROUTINE



      SUBROUTINE LEFT_RADIATING()
      REAL    :: Dtmp

      Dtmp = H(js+1) +SLO(js+1)
      IF (Dtmp .LT. 0. ) THEN
        Dtmp = 0.
      END IF
      SLO(js) = -uo(js+1)*SQRT(Dtmp/g)
      SLN(js) = SLO(js)

      END SUBROUTINE



      SUBROUTINE RIGHT_RADIATING()
      REAL    :: Dtmp

      Dtmp = H(JE-1) +SLO(JE-1)
      IF( Dtmp .LT. 0. ) THEN
        Dtmp = 0.
      END IF                     
      SLO(JE)=UO(JE)*SQRT(DTMP/G)
      SLN(JE)=SLO(JE)

      END SUBROUTINE
 


! ACTUAL EQUATIONS OF CONTINUITY
      SUBROUTINE CONT()
      REAL, DIMENSION(1:JE) :: FLUX
      REAL :: ULP, ULN

      FLUX=0.
   !  CELL(JS)=1
   !  CELL(JS+1)=1
      DO J = JS+1, JE   ! SET J=JE WHEN RADIATE, OTHERWISE J=JE-1
        IF (CELL(J) .EQ. 1 .AND. CELL(J-1) .EQ. 1)THEN    ! THIS CONTROLS ONLY ONE WALL (LEFT)
          ULP=0.5*(UN(J)+ABS(UN(J)))
          ULN=0.5*(UN(J)-ABS(UN(J)))
          FLUX(J)=ULP*SLO(J-1)+ULN*SLO(J)+DHU(J)*UN(J)
        END IF
      END DO

      DO J = JS+1, JE-1
        SLN(J)=SLO(J)-(FLUX(J+1)-FLUX(J))*THX
      END DO

      END SUBROUTINE




      SUBROUTINE VELOCITY()
      REAL, DIMENSION(1:JE) :: DU, UNN
      REAL, PARAMETER :: ALPHA = 0.02
      REAL :: DIST, DDU, UOP, UON

      UNN=0

!..   BOUNDARY
      DU(JS+1)=DHU(JS+1)+0.5*(SLO(JS)+SLO(JS+1))
      ! IF(DU(JS+1).LE.5.) DU(JS+1)=5.
      UN(JS+1)=UO(JS+1)-GTHX*(SLO(JS+1)-SLO(JS))
   !      -r*T*UO(JS+1)*abs(UO(JS+1))/du(JS+1)
      unn(js+1)=UN(JS+1)
      IF (Cell(js) .EQ. 0 .OR. Cell(js+1) .EQ. 0) then   !  addition 9-8-2018  BK
        UN(js+1) = 0.
        unn(js+1) = 0.
      END IF

!.. ENTIRE DOMAIN
      DO j = JS+2, JE-1
        DU(J)=DHU(J)+0.5*(SLO(J-1)+SLO(J))
        DDU=DU(J)
        IF(DU(J).LE.5.) DDU=5.   ! DEFENSE AGAINST ZERO DENOM. IN BOTTOM FRICTION

         UOP=0.5*(UO(j)+ABS(UO(j)))
         UON=0.5*(UO(J)-ABS(UO(J)))

         IF (Cell(j) .EQ. 1 .AND. Cell(j-1) .EQ. 1) then    ! additional test  9-8-2018  BK
           Un(j)=UO(J)-THX*(UOP*(UO(J)-UO(J-1))+UON*(UO(J+1)-UO(J))) &
           + GTHX*(SLO(j-1) - SLO(j))
    !     -r*T*UO(j)*abs(UO(j))/DDU
         END IF

      END DO


!.. BOUNDARY CONDITION FOR THE LAST RIGHT POINT
      UN(JE)=UO(JE)-GTHX*(SLO(JE)-SLO(JE-1))-r*T*UO(JE)*abs(UO(JE))/du(JE-1)
      IF (Cell(je) .EQ. 0 .OR. Cell(je-1) .EQ. 0) UN(Je) = 0.

!.. CHECK VELOCITY
      DO J=JS+2,JE-1  ! THIS IS ONLY BEAUTIFICATION (but a good one)
        IF (Cell(j) .EQ. 0 .AND. Cell(j-1) .EQ. 0)THEN
          UN(J)=0.
       !  IF((D(J-1)+D(J)).LE.0.) UN(J)=0.
        END IF
      END DO
              
      DO j = JS+1, JE-1
        IF (Cell(j) .EQ. 1 .AND. CELL(J+1) .EQ. 0) then
          if ((SLO(j) + h(j+1)) .LE. 0.) THEN    ! FOR THE BOUNDARY CONDITION U=0
            UN(J+1)=0.                           ! AT THE RIGHT WALL
          end if
        END IF

        IF (CELL(J-1) .EQ. 0 .AND. CELL(J) .EQ. 1) THEN
          if ((SLO(j) + h(j-1)) .LE. 0.) THEN    ! FOR THE BOUNDARY CONDITION U=0
            UN(J)=0.                      ! AT THE LEFT WALL             
          end if
        END IF
      END DO

      END SUBROUTINE



      SUBROUTINE WRITER_BEACH
      real :: x, vol
 
      x = -HX*float(je-1)/2.

!      open(unit=15,file='LEVEL_PARAB.dat',status='unknown')
!     open(unit=16,file='lev_anal.dat',status='unknown')

!.. test for volume conservation if necessary
      vol = 0.
      DO j = js, je
        x = SLAN(j)+H(j)
        IF (x .GT. 0.) vol = vol+x
       ! IF (D(J) .GT. 0.) vol = vol+D(j)
      END DO
 
!.. write out surface configuration
      IF (MOD(m, 50) .eq. 1) then
        !PRINT*,M, slo(50), slan(50)
        DO j=JS,Je
          write (15,"(3E14.4)") x*1.E-5, SLO(J), SLAN(j)
         write (16,"(2E14.4)") x*1.E-5, slan(J)
          x = x + Hx
!.. or simple writing
!..     write (15,*) SLO(J)
!..   write (16,*) slan(J)
        END DO
      END IF

      END subroutine




      SUBROUTINE runup_rundown()

      DO j = JS+1, JE - 1
        IF (Cell(j) .EQ. 1 .AND. CELL(J+1) .EQ. 0) then ! dRY TO
          if ((SLO(j) + h(j+1)) .GT. EPSILON) then    !RIGHT
            D(J+1)= SLO(j) + h(j+1)
            Cell(j+1) = 1
 !          SLO(J+1) = SLO(j)
            if (CELL(J-1) .EQ. 1)THEN
              UO(J+1)=UO(J)
            end if
            if (CELL(J-1) .EQ. 0)THEN   !CELL SURROUNDED BY
              UO(J+1) = SQRT(G*D(J+1)) ! DRY CELLS
            end if
          end if
        END IF

        IF (CELL(J-1) .EQ. 0 .AND. CELL(J) .EQ. 1) THEN
          if ((SLO(J) + H(J-1)) .GT. EPSILON) then
            D(J-1)= SLO(J) + H(J-1)
            CELL(J-1) = 1
   !        SLO(J-1) = SLO(J)        !
            if (CELL(J+1) .EQ. 1)THEN
              UO(J)=UO(J+1)
            end if
            if (CELL(J+1) .EQ. 0)THEN !CELL(J) SURROUNDER
              UO(J)=-SQRT(G*D(J-1)) !BY DRY CELLS
            end if
          end if
        END IF
      END DO

      END Subroutine runup_rundown



   END PROGRAM   RUNUP
